import uno
import unohelper

from com.sun.star.lang import XServiceInfo
from com.sun.star.uno import XWeak

from names.nick.openoffice import XTestOOComp

class MyTestOOCompPythonImpl(unohelper.Base, XServiceInfo, XWeak, XTestOOComp):

  OODouble=47.3
  OOLong=60000
  OOString="MyStr"

  ServiceNames=("names.nick.openoffice.STestOOComp",)
  ImplementationName=XTestOOComp.__name__
  ImplementationName=ImplementationName.replace(".X",".") + "PythonImpl"

  def __init__(self,setCtx=None):
    self.m_xContext=setCtx

  def OOCompFunction(self,a,b):
    return a+b

  #  The following block of code should not be necessary to properly implement
  #  an OpenOffice Interface with attributes OODouble, OOLong, OOString.
  #  If used (i.e. comments below removed), the attributes become "pseudo-properties" in OO
  ############
  #def getOODouble(self):
  #  return self.OODouble
  #def setOODouble(self,setOODouble):
  #  self.OODouble=set_OODouble
  # 
  #def getOOLong(self):
  #  return self.OOLong
  #def setOOLong(self,set_OOLong):
  #  self.OOLong=set_OOLong
  # 
  #def getOOString(self):
  #  return self.OOString
  #def setOOString(self,set_OOString):
  #  self.OOString=set_OOString
  ############

  def getImplementationName(self):
    return self.ImplementationName

  def supportsService(self,sService):
    slen=len(self.ServiceNames)
    for i in range(slen):
      if self.ServiceNames[i] == sService:
        return True
    return False

  def getSupportedServiceNames(self):
    return self.ServiceNames

  def queryAdapter(self):
    return None

g_ImplementationHelper = unohelper.ImplementationHelper()
g_ImplementationHelper.addImplementation(MyTestOOCompPythonImpl,"names.nick.openoffice.TestOOCompPythonImpl",("com.sun.star.task.Job",),)
