package names.nick.openoffice;

import com.sun.star.uno.XComponentContext;
import com.sun.star.lib.uno.helper.Factory;
import com.sun.star.lang.XSingleComponentFactory;
import com.sun.star.registry.XRegistryKey;
import com.sun.star.lib.uno.helper.WeakBase;


public final class TestOOCompJavaImpl extends WeakBase
   implements com.sun.star.lang.XServiceInfo,
              names.nick.openoffice.XTestOOComp
{
    private final XComponentContext m_xContext;
    private static final String m_implementationName = TestOOCompJavaImpl.class.getName();
    private static final String[] m_serviceNames = {
        "names.nick.openoffice.STestOOComp" };


    public TestOOCompJavaImpl( XComponentContext context )
    {
        m_xContext = context;
    };

    public static XSingleComponentFactory __getComponentFactory( String sImplementationName ) {
        XSingleComponentFactory xFactory = null;

        if ( sImplementationName.equals( m_implementationName ) )
            xFactory = Factory.createComponentFactory(TestOOCompJavaImpl.class, m_serviceNames);
        return xFactory;
    }

    public static boolean __writeRegistryServiceInfo( XRegistryKey xRegistryKey ) {
        return Factory.writeRegistryServiceInfo(m_implementationName,
                                                m_serviceNames,
                                                xRegistryKey);
    }

    // com.sun.star.lang.XServiceInfo:
    public String getImplementationName() {
         return m_implementationName;
    }

    public boolean supportsService( String sService ) {
        int len = m_serviceNames.length;

        for( int i=0; i < len; i++) {
            if (sService.equals(m_serviceNames[i]))
                return true;
        }
        return false;
    }

    public String[] getSupportedServiceNames() {
        return m_serviceNames;
    }

    // names.nick.openoffice.XTestOOComp:
    public double getOODouble()
    {
        return 0;
    }

    public void setOODouble(double the_value)
    {

    }

    public int getOOLong()
    {
        return 0;
    }

    public void setOOLong(int the_value)
    {

    }

    public String getOOString()
    {
        return new String();
    }

    public void setOOString(String the_value)
    {

    }

    public double OOCompFunction(double a, double b)
    {
        // TODO: Exchange the default return implementation for "OOCompFunction" !!!
        // NOTE: Default initialized polymorphic structs can cause problems
        // because of missing default initialization of primitive types of
        // some C++ compilers or different Any initialization in Java and C++
        // polymorphic structs.
        return 0;
    }

}
